diff -r -uw -N irrlicht/source/Irrlicht/CD3D9ParallaxMapRenderer.cpp irrlicht_multipatch/source/Irrlicht/CD3D9ParallaxMapRenderer.cpp
--- irrlicht/source/Irrlicht/CD3D9ParallaxMapRenderer.cpp	2006-10-15 08:48:46.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9ParallaxMapRenderer.cpp	2006-12-05 12:19:34.000000000 +0100
@@ -221,7 +221,7 @@
 		"\n";	
 
 	CD3D9ParallaxMapRenderer::CD3D9ParallaxMapRenderer(
-		IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+		core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, IMaterialRenderer* baseMaterial)
 		: CD3D9ShaderMaterialRenderer(d3ddev, driver, 0, baseMaterial),
 		CurrentScale(0.0f)
@@ -233,9 +233,8 @@
 
 		// basicly, this thing simply compiles these hardcoded shaders if the
 		// hardware is able to do them, otherwise it maps to the base material
-
-		if (!driver->queryFeature(video::EVDF_PIXEL_SHADER_1_4) ||
-			!driver->queryFeature(video::EVDF_VERTEX_SHADER_1_1))
+		if (!driver->queryFeature(video::EVDF_PIXEL_SHADER_1_4, deviceIndex) ||
+			!driver->queryFeature(video::EVDF_VERTEX_SHADER_1_1, deviceIndex))
 		{
 			// this hardware is not able to do shaders. Fall back to
 			// base material.
@@ -248,16 +247,21 @@
 		video::IMaterialRenderer* renderer = driver->getMaterialRenderer(EMT_PARALLAX_MAP_SOLID);
 		if (renderer)
 		{
+			u32 idx = 0;
 			// use the already compiled shaders 
 			video::CD3D9ParallaxMapRenderer* nmr = (video::CD3D9ParallaxMapRenderer*)renderer;
-			VertexShader = nmr->VertexShader;
-			if (VertexShader)
-				VertexShader->AddRef();
-
-			PixelShader = nmr->PixelShader;
-			if (PixelShader)
-				PixelShader->AddRef();
-
+			for(idx = 0; idx < nmr->VertexShaders.size(); ++idx)
+			{
+				VertexShaders.push_back(nmr->VertexShaders[idx]);
+				if (VertexShaders[idx])
+					VertexShaders[idx]->AddRef();
+			}
+			for(idx = 0; idx < nmr->VertexShaders.size(); ++idx)
+			{
+				PixelShaders.push_back(nmr->PixelShaders[idx]);
+				if (PixelShaders[idx])
+					PixelShaders[idx]->AddRef();
+			}
 			outMaterialTypeNr = driver->addMaterialRenderer(this);
 		}
 		else
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9ParallaxMapRenderer.h irrlicht_multipatch/source/Irrlicht/CD3D9ParallaxMapRenderer.h
--- irrlicht/source/Irrlicht/CD3D9ParallaxMapRenderer.h	2006-06-17 08:12:08.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9ParallaxMapRenderer.h	2006-11-30 18:45:16.000000000 +0100
@@ -26,7 +26,7 @@
 public:
 
 	CD3D9ParallaxMapRenderer(
-		IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+		core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, IMaterialRenderer* baseMaterial);
 
 	~CD3D9ParallaxMapRenderer();
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9ShaderMaterialRenderer.cpp irrlicht_multipatch/source/Irrlicht/CD3D9ShaderMaterialRenderer.cpp
--- irrlicht/source/Irrlicht/CD3D9ShaderMaterialRenderer.cpp	2006-06-17 08:11:54.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9ShaderMaterialRenderer.cpp	2006-12-11 13:57:51.000000000 +0100
@@ -23,12 +23,19 @@
 {
 
 //! Public constructor
-CD3D9ShaderMaterialRenderer::CD3D9ShaderMaterialRenderer(IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+	CD3D9ShaderMaterialRenderer::CD3D9ShaderMaterialRenderer(core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, const c8* vertexShaderProgram, const c8* pixelShaderProgram,
 		IShaderConstantSetCallBack* callback, IMaterialRenderer* baseMaterial, s32 userData)
-: pID3DDevice(d3ddev), Driver(driver), BaseMaterial(baseMaterial), CallBack(callback),
-	VertexShader(0), PixelShader(0), UserData(userData)
+:  Driver(driver), BaseMaterial(baseMaterial), CallBack(callback), UserData(userData)
 {
+	for(u32 idx = 0; idx < d3ddev.size(); ++idx)
+	{
+		pID3DDevices.push_back(d3ddev[idx]);
+		VertexShaders.push_back(NULL);
+		PixelShaders.push_back(NULL);
+		OldVertexShaders.push_back(NULL);
+	}
+
 	if (BaseMaterial)
 		BaseMaterial->grab();
 
@@ -36,25 +43,35 @@
 		CallBack->grab();
 
 	init(outMaterialTypeNr, vertexShaderProgram, pixelShaderProgram);
+	deviceIndex = 0;
 }
 
 
 
 //! constructor only for use by derived classes who want to
 //! create a fall back material for example.
-CD3D9ShaderMaterialRenderer::CD3D9ShaderMaterialRenderer(IDirect3DDevice9* d3ddev,
+CD3D9ShaderMaterialRenderer::CD3D9ShaderMaterialRenderer(core::array<IDirect3DDevice9*> d3ddev,
 														 video::IVideoDriver* driver, 
 														 IShaderConstantSetCallBack* callback,
 														 IMaterialRenderer* baseMaterial,
 														 s32 userData)
-: pID3DDevice(d3ddev), Driver(driver), BaseMaterial(baseMaterial), CallBack(callback),
-	VertexShader(0), PixelShader(0), UserData(userData)
+: Driver(driver), BaseMaterial(baseMaterial), CallBack(callback), UserData(userData)
+{
+	for(u32 idx = 0; idx < d3ddev.size(); ++idx)
 {
+		pID3DDevices.push_back(d3ddev[idx]);
+		VertexShaders.push_back(NULL);
+		PixelShaders.push_back(NULL);
+		OldVertexShaders.push_back(NULL);
+	}
+
 	if (BaseMaterial)
 		BaseMaterial->grab();
 
 	if (CallBack)
 		CallBack->grab();
+
+	deviceIndex = 0;
 }
 
 
@@ -63,6 +80,10 @@
 {
 	outMaterialTypeNr = -1;
 
+	for(u32 idx = 0; idx < pID3DDevices.size(); ++idx)
+	{
+		deviceIndex = idx;
+
 	// create vertex shader
 	if (!createVertexShader(vertexShaderProgram))
 		return;
@@ -70,6 +91,7 @@
 	// create pixel shader
 	if (!createPixelShader(pixelShaderProgram))
 		return;
+	}
 
 	// register myself as new material
 	outMaterialTypeNr = Driver->addMaterialRenderer(this);
@@ -83,21 +105,34 @@
 	if (CallBack)
 		CallBack->drop();
 
-	if (VertexShader)
-		VertexShader->Release();
+	for(u32 idx = 0; idx < VertexShaders.size(); ++idx)
+	{
+		if(VertexShaders[idx])
+			VertexShaders[idx]->Release();
+	}
+
+	VertexShaders.clear();
 
-	if (PixelShader)
-		PixelShader->Release();
+	for(u32 idx = 0; idx < PixelShaders.size(); ++idx)
+	{
+		if(PixelShaders[idx])
+			PixelShaders[idx]->Release();
+	}
+	PixelShaders.clear();
 
 	if (BaseMaterial)
 		BaseMaterial->drop ();
+
+	pID3DDevices.clear();
 }
 
 bool CD3D9ShaderMaterialRenderer::OnRender(IMaterialRendererServices* service, E_VERTEX_TYPE vtxtype)
 {
 	// call callback to set shader constants
-	if (CallBack && (VertexShader || PixelShader))
+	if (CallBack && (VertexShaders[deviceIndex] || PixelShaders[deviceIndex]))
+	{
 		CallBack->OnSetConstants(service, UserData);
+	}
 
 	return true;
 }
@@ -107,49 +142,74 @@
 {
 	if (material.MaterialType != lastMaterial.MaterialType || resetAllRenderstates)
 	{		
-		if (VertexShader)
+		if (VertexShaders[deviceIndex])
 		{
+
 			// save old vertex shader
-			pID3DDevice->GetVertexShader(&OldVertexShader);
+			pID3DDevices[deviceIndex]->GetVertexShader(&OldVertexShaders[deviceIndex]);
 			
 			// set new vertex shader
-			if (FAILED(pID3DDevice->SetVertexShader(VertexShader)))
+			if (FAILED(pID3DDevices[deviceIndex]->SetVertexShader(VertexShaders[deviceIndex])))
 				os::Printer::log("Could not set vertex shader.");
 		}
+		else
+		{
+			char tmp[255];
+			sprintf(tmp, "could not set the vertex shader on device %d", deviceIndex);
+			os::Printer::log(tmp, ELL_ERROR);
+		}
+
 
 		// set new pixel shader
-		if (PixelShader)
+		if (PixelShaders[deviceIndex])
 		{
-			if (FAILED(pID3DDevice->SetPixelShader(PixelShader)))
+			if (FAILED(pID3DDevices[deviceIndex]->SetPixelShader(PixelShaders[deviceIndex])))
 				os::Printer::log("Could not set pixel shader.");
 		}
+		else
+		{
+			char tmp[255];
+			sprintf(tmp, "could not set the pixel shader on device %d", deviceIndex);
+			os::Printer::log(tmp, ELL_ERROR);
+		}
 
 		if (BaseMaterial)
+		{
+			BaseMaterial->setRenderDevice(deviceIndex);
 			BaseMaterial->OnSetMaterial(material, material, true, services);
 	}
+	}
 
 	services->setBasicRenderStates(material, lastMaterial, resetAllRenderstates);
 }
 
 void CD3D9ShaderMaterialRenderer::OnUnsetMaterial() 
 {
-	if (VertexShader)
-		pID3DDevice->SetVertexShader(OldVertexShader);
+	if (VertexShaders[deviceIndex])
+		pID3DDevices[deviceIndex]->SetVertexShader(OldVertexShaders[deviceIndex]);
 
-	if (PixelShader)
-		pID3DDevice->SetPixelShader(0);
+	if (PixelShaders[deviceIndex])
+		pID3DDevices[deviceIndex]->SetPixelShader(0);
 
 	if (BaseMaterial)
+	{
+		BaseMaterial->setRenderDevice(deviceIndex);
 		BaseMaterial->OnUnsetMaterial();
 }
+}
 
 	
 //! Returns if the material is transparent. The scene managment needs to know this
 //! for being able to sort the materials by opaque and transparent.
 bool CD3D9ShaderMaterialRenderer::isTransparent() 
 {
+	if(BaseMaterial)
+	{
+		BaseMaterial->setRenderDevice(deviceIndex);
 	return BaseMaterial ? BaseMaterial->isTransparent() : false; 
 }
+	return false;
+}
 
 bool CD3D9ShaderMaterialRenderer::createPixelShader(const c8* pxsh)
 {
@@ -195,7 +255,7 @@
 		return false;
 	}
 
-	if (FAILED(pID3DDevice->CreatePixelShader((DWORD*)code->GetBufferPointer(), &PixelShader)))
+	if (FAILED(pID3DDevices[deviceIndex]->CreatePixelShader((DWORD*)code->GetBufferPointer(), &PixelShaders[deviceIndex])))
 	{
 		os::Printer::log("Could not create pixel shader.");
 		code->Release();
@@ -253,7 +313,7 @@
 		return false;
 	}
 
-	if (!code || FAILED(pID3DDevice->CreateVertexShader((DWORD*)code->GetBufferPointer(), &VertexShader)))
+	if (FAILED(pID3DDevices[deviceIndex]->CreateVertexShader((DWORD*)code->GetBufferPointer(), &VertexShaders[deviceIndex])))
 	{
 		os::Printer::log("Could not create vertex shader.");
 		if (code)
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9ShaderMaterialRenderer.h irrlicht_multipatch/source/Irrlicht/CD3D9ShaderMaterialRenderer.h
--- irrlicht/source/Irrlicht/CD3D9ShaderMaterialRenderer.h	2006-06-17 08:11:54.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9ShaderMaterialRenderer.h	2006-11-30 18:55:34.000000000 +0100
@@ -13,6 +13,7 @@
 #include <d3dx9shader.h>
 
 #include "IMaterialRenderer.h"
+#include "irrArray.h"
 
 namespace irr
 {
@@ -29,7 +30,7 @@
 public:
 
 	//! Public constructor
-	CD3D9ShaderMaterialRenderer(IDirect3DDevice9* d3ddev, video::IVideoDriver* driver, 
+	CD3D9ShaderMaterialRenderer(core::array<IDirect3DDevice9*> d3ddev, video::IVideoDriver* driver, 
 		s32& outMaterialTypeNr, const c8* vertexShaderProgram, const c8* pixelShaderProgram,
 		IShaderConstantSetCallBack* callback, IMaterialRenderer* baseMaterial, s32 userData);
 
@@ -50,7 +51,7 @@
 
 	//! constructor only for use by derived classes who want to
 	//! create a fall back material for example.
-	CD3D9ShaderMaterialRenderer(IDirect3DDevice9* d3ddev,
+	CD3D9ShaderMaterialRenderer(core::array<IDirect3DDevice9*> d3ddev,
 								video::IVideoDriver* driver, 
 								IShaderConstantSetCallBack* callback,
 								IMaterialRenderer* baseMaterial, s32 userData=0);
@@ -79,14 +80,14 @@
 								LPCSTR pProfile, DWORD Flags, LPD3DXBUFFER* ppShader, LPD3DXBUFFER* ppErrorMsgs,
 								LPD3DXCONSTANTTABLE* ppConstantTable);
 
-	IDirect3DDevice9* pID3DDevice;
+	core::array<IDirect3DDevice9*> pID3DDevices;
 	video::IVideoDriver* Driver;
 	IShaderConstantSetCallBack* CallBack;
 	IMaterialRenderer* BaseMaterial;
 
-	IDirect3DVertexShader9* VertexShader;
-	IDirect3DVertexShader9* OldVertexShader;
-	IDirect3DPixelShader9* PixelShader;
+	core::array<IDirect3DVertexShader9*> VertexShaders;
+	core::array<IDirect3DVertexShader9*> OldVertexShaders;
+	core::array<IDirect3DPixelShader9*> PixelShaders;
 	s32 UserData;
 };
 
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9Texture.cpp irrlicht_multipatch/source/Irrlicht/CD3D9Texture.cpp
--- irrlicht/source/Irrlicht/CD3D9Texture.cpp	2006-10-15 08:48:50.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9Texture.cpp	2006-12-08 11:42:10.000000000 +0100
@@ -31,29 +31,51 @@
 {
 
 //! rendertarget constructor
-CD3D9Texture::CD3D9Texture(CD3D9Driver* driver, core::dimension2d<s32> size, const char* name)
+CD3D9Texture::CD3D9Texture(IVideoDriver* driver, core::dimension2d<s32> size, const char* name)
 : ITexture(name), Image(0), Driver(driver), TextureSize(size),
-	Texture(0), Pitch(0), ImageSize(size), HasMipMaps(0), HardwareMipMaps(0),
-	IsRenderTarget(true), RTTSurface(0)
+	Pitch(0), ImageSize(size), HasMipMaps(0), HardwareMipMaps(0),
+	IsRenderTarget(true)
 {
 	#ifdef _DEBUG
 	setDebugName("CD3D9Texture");
 	#endif
 
-	Device=driver->getExposedVideoData().D3D9.D3DDev9;
-	if (Device)
-		Device->AddRef();
+	RTTSurfaces.push_back(NULL);
 
-	createRenderTarget();
+	Devices.push_back(driver->getExposedVideoData().D3D9.D3DDev9);
+
+	if (Devices[Devices.size()-1])
+		Devices[Devices.size()-1]->AddRef();
+
+	createRenderTarget(Devices[Devices.size()-1]);
+}
+//! rendertarget multihead constructor
+CD3D9Texture::CD3D9Texture(IVideoDriver* driver, core::array<IDirect3DDevice9*> devices, core::dimension2d<s32> size, const char* name)
+: ITexture(name), Image(0), Driver(driver), TextureSize(size),
+	Pitch(0), ImageSize(size), HasMipMaps(0), HardwareMipMaps(0),
+	IsRenderTarget(true)
+{
+	#ifdef _DEBUG
+    setDebugName("CD3D9Texture");
+	#endif
+
+	for(u32 idx = 0; idx < devices.size(); ++idx)
+	{
+		RTTSurfaces.push_back(NULL);
+		Devices.push_back(devices[idx]);
+		if(Devices[Devices.size()-1])
+			Devices[Devices.size()-1]->AddRef();
+		createRenderTarget(Devices[Devices.size()-1]);
+	}
 }
 
 
 //! constructor
-CD3D9Texture::CD3D9Texture(IImage* image, CD3D9Driver* driver,
+CD3D9Texture::CD3D9Texture(IImage* image, IVideoDriver* driver,
 					   u32 flags, const char* name)
 : ITexture(name), Image(image), Driver(driver), TextureSize(0,0),
-Texture(0), Pitch(0), ImageSize(0,0), HasMipMaps(false), HardwareMipMaps(false),
-IsRenderTarget(false), RTTSurface(0)
+Pitch(0), ImageSize(0,0), HasMipMaps(false), HardwareMipMaps(false),
+IsRenderTarget(false)
 {
 	#ifdef _DEBUG
 	setDebugName("CD3D9Texture");
@@ -61,17 +83,19 @@
 
 	bool generateMipLevels = (flags & video::ETCF_CREATE_MIP_MAPS) != 0;
 
-	Device=driver->getExposedVideoData().D3D9.D3DDev9;
-	if (Device)
-		Device->AddRef();
+	RTTSurfaces.push_back(NULL);
+
+	Devices.push_back(driver->getExposedVideoData().D3D9.D3DDev9);
+	if (Devices[Devices.size()-1])
+		Devices[Devices.size()-1]->AddRef();
 
 	if (Image)
 	{
 		Image->grab();
 
-		createTexture(flags);
+		createTexture(flags, Devices.size()-1);
 
-		if (Texture)
+		if (Textures[0])
 		{
 			if (copyTexture() && generateMipLevels)
 			{
@@ -81,7 +105,7 @@
 					// compiling with both D3D8 and 9, causing it not to work in the D3D9 device.
 					// So mipmapgeneration is replaced with my own bad generation in d3d 8 when
 					// compiling with both D3D 8 and 9.
-					HRESULT hr  = D3DXFilterTexture(Texture, NULL, D3DX_DEFAULT, D3DX_DEFAULT);
+					HRESULT hr  = D3DXFilterTexture(Textures[0], NULL, D3DX_DEFAULT, D3DX_DEFAULT);
 					if (FAILED(hr))
 						os::Printer::log("Could not create direct3d mip map levels.", ELL_WARNING);
 					else
@@ -97,8 +121,60 @@
 	}
 }
 
+//! multihead constructor
+CD3D9Texture::CD3D9Texture(IImage* image, IVideoDriver* driver, core::array<IDirect3DDevice9*> devices, u32 flags, const char* name)
+: ITexture(name), Image(image), Driver(driver), TextureSize(0,0),
+Pitch(0), ImageSize(0,0), HasMipMaps(false), HardwareMipMaps(false),
+IsRenderTarget(false)
+{
+	#ifdef _DEBUG
+    setDebugName("CD3D9Texture");
+	#endif
+
+	bool generateMipLevels = (flags & video::ETCF_CREATE_MIP_MAPS) != 0;
+
+	for(u32 idx = 0; idx < devices.size(); ++idx)
+	{
+		RTTSurfaces.push_back(NULL);
+		Devices.push_back(devices[idx]);
+		if(Devices[Devices.size()-1])
+			Devices[Devices.size()-1]->AddRef();
+	
+		if (Image)
+		{
+			Image->grab();
+
+			createTexture(flags, Devices.size()-1);
+
+			if (Textures[idx])
+			{
+				if (copyTexture(idx) && generateMipLevels)
+				{
+					// create mip maps.
+					#ifndef _IRR_COMPILE_WITH_DIRECT3D_8_
+						// The D3DXFilterTexture function seems to get linked wrong when
+						// compiling with both D3D8 and 9, causing it not to work in the D3D9 device.
+						// So mipmapgeneration is replaced with my own bad generation in d3d 8 when
+						// compiling with both D3D 8 and 9.
+						HRESULT hr  = D3DXFilterTexture(Textures[idx], NULL, D3DX_DEFAULT, D3DX_DEFAULT);
+						if (FAILED(hr))
+							os::Printer::log("Could not create direct3d mip map levels.", ELL_WARNING);
+						else
+							HasMipMaps = true;
+					#else
+						createMipMaps(1,idx);
+						HasMipMaps = true;
+					#endif
+				}				
+			}
+			else
+				os::Printer::log("Could not create DIRECT3D9 Texture.", ELL_WARNING);
+		}
+	}
+}
+
 
-void CD3D9Texture::createRenderTarget()
+void CD3D9Texture::createRenderTarget(IDirect3DDevice9 *device)
 {
 	TextureSize.Width = getTextureSizeFromImageSize(TextureSize.Width);
 	TextureSize.Height = getTextureSizeFromImageSize(TextureSize.Height);
@@ -109,7 +185,7 @@
 	IDirect3DSurface9* bb;
 	D3DFORMAT d3DFormat = D3DFMT_A8R8G8B8;
 
-	if (!FAILED(Device->GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, &bb)))
+	if (!FAILED(device->GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, &bb)))
 	{
 		D3DSURFACE_DESC desc;
 		bb->GetDesc(&desc);
@@ -129,17 +205,19 @@
 
 	// create texture
 	HRESULT hr;
+	IDirect3DTexture9* tex;
 
-	hr = Device->CreateTexture(
+	hr = device->CreateTexture(
 		TextureSize.Width,
 		TextureSize.Height,
 		1, // mip map level count, we don't want mipmaps here
 		D3DUSAGE_RENDERTARGET,
 		d3DFormat,
 		D3DPOOL_DEFAULT,
-		&Texture,
+		&tex,
 		NULL);
 
+	Textures.push_back(tex);
 	// get irrlicht format from D3D format
 
 	switch(d3DFormat)
@@ -165,13 +243,13 @@
 }
 
 
-bool CD3D9Texture::createMipMaps(s32 level)
+bool CD3D9Texture::createMipMaps(s32 level, u32 idx)
 {
-	if (HardwareMipMaps && Texture)
+	if (HardwareMipMaps && Textures[idx])
 	{
 		// generate mipmaps in hardware
 
-		Texture->GenerateMipSubLevels();
+		Textures[idx]->GenerateMipSubLevels();
 		return true;
 	}
 	//os::Printer::log("manual mipmap");
@@ -185,7 +263,7 @@
 	IDirect3DSurface9* lowerSurface = 0;
 
 	// get upper level
-	HRESULT hr = Texture->GetSurfaceLevel(level-1, &upperSurface);
+	HRESULT hr = Textures[idx]->GetSurfaceLevel(level-1, &upperSurface);
 	if (FAILED(hr) || !upperSurface)
 	{
 		os::Printer::log("Could get upper surface level for mip map generation", ELL_WARNING);
@@ -193,7 +271,7 @@
 	}
 
 	// get lower level
-	hr = Texture->GetSurfaceLevel(level, &lowerSurface);
+	hr = Textures[idx]->GetSurfaceLevel(level, &lowerSurface);
 	if (FAILED(hr) || !lowerSurface)
 	{
 		os::Printer::log("Could get lower surface level for mip map generation", ELL_WARNING);
@@ -255,23 +333,31 @@
 		return true; // stop generating levels
 
 	// generate next level
-	return createMipMaps(level+1);
+	return createMipMaps(level+1, idx);
 }
 
 
 //! creates the hardware texture
-void CD3D9Texture::createTexture(u32 flags)
+void CD3D9Texture::createTexture(u32 flags, u32 renderDevice)
 {
 	core::dimension2d<s32> optSize;
 	ImageSize = Image->getDimension();
 
-	if (Driver->queryFeature(EVDF_TEXTURE_NPOT))
+	if(Driver)
+	{
+		if (Driver->queryFeature(EVDF_TEXTURE_NPOT, renderDevice))
 		optSize=ImageSize;
 	else
 	{
 		optSize.Width = getTextureSizeFromImageSize(ImageSize.Width);
 		optSize.Height = getTextureSizeFromImageSize(ImageSize.Height);
 	}
+	}
+	else
+	{
+		optSize.Width = getTextureSizeFromImageSize(ImageSize.Width);
+		optSize.Height = getTextureSizeFromImageSize(ImageSize.Height);
+	}
 
 	HRESULT hr;
 	D3DFORMAT format = D3DFMT_A1R5G5B5;
@@ -313,10 +399,12 @@
 	//	HardwareMipMaps = true;
 	//}
 
-	hr = Device->CreateTexture(optSize.Width, optSize.Height,
+	IDirect3DTexture9* tex;
+
+	hr = Devices[renderDevice]->CreateTexture(optSize.Width, optSize.Height,
 		mipmaps ? 0 : 1, // number of mipmaplevels (0 = automatic all)
 		usage, // usage
-		format, D3DPOOL_MANAGED , &Texture, NULL);
+		format, D3DPOOL_MANAGED , &tex, NULL);
 
 	if (FAILED(hr) && format == D3DFMT_A8R8G8B8)
 	{
@@ -324,10 +412,11 @@
 
 		format = D3DFMT_A1R5G5B5;
 
-		hr = Device->CreateTexture(optSize.Width, optSize.Height,
+		hr = Devices[renderDevice]->CreateTexture(optSize.Width, optSize.Height,
 			(flags & ETCF_CREATE_MIP_MAPS) ? 0 : 1, // number of mipmaplevels (0 = automatic all)
-			0, D3DFMT_A1R5G5B5, D3DPOOL_MANAGED, &Texture, NULL);
+			0, D3DFMT_A1R5G5B5, D3DPOOL_MANAGED, &tex, NULL);
 	}
+	Textures.push_back(tex);
 
 	ColorFormat = (format == D3DFMT_A1R5G5B5) ? ECF_A1R5G5B5 : ECF_A8R8G8B8;
 }
@@ -335,12 +424,12 @@
 
 
 //! copies the image to the texture
-bool CD3D9Texture::copyTexture()
+bool CD3D9Texture::copyTexture(u32 index)
 {
-	if (Texture && Image)
+	if (Textures[index] && Image)
 	{
 		D3DSURFACE_DESC desc;
-		Texture->GetLevelDesc(0, &desc);
+		Textures[index]->GetLevelDesc(0, &desc);
 
 		TextureSize.Width = desc.Width;
 		TextureSize.Height = desc.Height;
@@ -348,10 +437,10 @@
 		SurfaceHasSameSize = (TextureSize == ImageSize);
 
 		if (desc.Format == D3DFMT_A1R5G5B5)
-			return copyTo16BitTexture();
+			return copyTo16BitTexture(index);
 		else
 		if (desc.Format == D3DFMT_A8R8G8B8)
-			return copyTo32BitTexture();
+			return copyTo32BitTexture(index);
 		else
 			os::Printer::log("CD3D9Texture: Unsupported D3D9 hardware texture format", ELL_ERROR);
 	}
@@ -361,10 +450,10 @@
 
 
 //! copies texture to 32 bit hardware texture
-bool CD3D9Texture::copyTo32BitTexture()
+bool CD3D9Texture::copyTo32BitTexture(u32 index)
 {
 	D3DLOCKED_RECT rect;
-	HRESULT hr = Texture->LockRect(0, &rect, 0, 0);
+	HRESULT hr = Textures[index]->LockRect(0, &rect, 0, 0);
 	if (FAILED(hr))
 	{
 		os::Printer::log("Could not lock DIRECT3D9 32 bit Texture.", ELL_ERROR);
@@ -438,7 +527,7 @@
 
 	Image->unlock();
 
-	hr = Texture->UnlockRect(0);
+	hr = Textures[index]->UnlockRect(0);
 	if (FAILED(hr))
 	{
 		os::Printer::log("Could not unlock DIRECT3D9 Texture.", ELL_ERROR);
@@ -451,10 +540,10 @@
 
 
 //! optimized for 16 bit to 16 copy.
-bool CD3D9Texture::copyTo16BitTexture()
+bool CD3D9Texture::copyTo16BitTexture(u32 index)
 {
 	D3DLOCKED_RECT rect;
-	HRESULT hr = Texture->LockRect(0, &rect, 0, 0);
+	HRESULT hr = Textures[index]->LockRect(0, &rect, 0, 0);
 	if (FAILED(hr))
 	{
 		os::Printer::log("Could not lock DIRECT3D9 16 bit Texture.", ELL_ERROR);
@@ -530,7 +619,7 @@
 
 	Image->unlock();
 
-	hr = Texture->UnlockRect(0);
+	hr = Textures[index]->UnlockRect(0);
 	if (FAILED(hr))
 	{
 		os::Printer::log("Could not unlock DIRECT3D9 16 bit Texture.", ELL_ERROR);
@@ -545,17 +634,32 @@
 //! destructor
 CD3D9Texture::~CD3D9Texture()
 {
-	if (Device)
-		Device->Release();
+
+	u32 idx = 0;
+
+	for(idx = 0; idx < Devices.size(); ++idx)
+	{
+		if(Devices[idx])
+			Devices[idx]->Release();
+	}
+	Devices.clear();
 
 	if (Image)
 		Image->drop();
 
-	if (Texture)
-		Texture->Release();
+	for(idx = 0; idx < Textures.size(); ++idx)
+	{
+		if(Textures[idx])
+			Textures[idx]->Release();
+	}
+	Textures.clear();
 
-	if (RTTSurface)
-		RTTSurface->Release();
+	for(idx = 0; idx < RTTSurfaces.size(); ++idx)
+	{
+		if(RTTSurfaces[idx])
+			RTTSurfaces[idx]->Release();
+	}
+	RTTSurfaces.clear();
 }
 
 
@@ -563,22 +667,22 @@
 //! lock function
 void* CD3D9Texture::lock()
 {
-	if (!Texture)
+	if (!Textures[0])
 		return 0;
 
 	HRESULT hr;
 	D3DLOCKED_RECT rect;
 	if(!IsRenderTarget)
 	{
-		hr = Texture->LockRect(0, &rect, 0, 0);
+		hr = Textures[0]->LockRect(0, &rect, 0, 0);
 	}
 	else
 	{
 		D3DSURFACE_DESC desc;
-		Texture->GetLevelDesc(0, &desc);
-		if (!RTTSurface)
+		Textures[0]->GetLevelDesc(0, &desc);
+		if (!RTTSurfaces[0])
 		{
-			hr = Device->CreateOffscreenPlainSurface(desc.Width, desc.Height, desc.Format, D3DPOOL_SYSTEMMEM, &RTTSurface, NULL);
+			hr = Devices[0]->CreateOffscreenPlainSurface(desc.Width, desc.Height, desc.Format, D3DPOOL_SYSTEMMEM, &RTTSurfaces[0], NULL);
 			if (FAILED(hr))
 			{
 				os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
@@ -587,24 +691,25 @@
 		}
 
 		IDirect3DSurface9 *surface = NULL;
-		hr = Texture->GetSurfaceLevel(0, &surface);
+		hr = Textures[0]->GetSurfaceLevel(0, &surface);
 		if (FAILED(hr))
 		{
 			os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
 			return 0;
 		}
-		hr = Device->GetRenderTargetData(surface, RTTSurface);
+		hr = Devices[0]->GetRenderTargetData(surface, RTTSurfaces[0]);
 		if(FAILED(hr))
 		{
 			os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
 			return 0;
 		}
-		hr = RTTSurface->LockRect(&rect, NULL, 0);
+		hr = RTTSurfaces[0]->LockRect(&rect, NULL, 0);
 		if(FAILED(hr))
 		{
 			os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
 			return 0;
 		}
+		surfaceBits = rect.pBits;
 		return rect.pBits;
 	}
 	if (FAILED(hr))
@@ -612,7 +717,7 @@
 		os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
 		return 0;
 	}
-
+	textureBits = rect.pBits;
 	return rect.pBits;
 }
 
@@ -621,13 +726,84 @@
 //! unlock function
 void CD3D9Texture::unlock()
 {
-	if (!Texture)
+	if (!Textures[0])
 		return;
 
+	u32 idx = 0;
+	D3DLOCKED_RECT rect;
+	D3DSURFACE_DESC desc;
+	HRESULT hr;
+
 	if (!IsRenderTarget)
-		Texture->UnlockRect(0);
-	else if (RTTSurface)
-		RTTSurface->UnlockRect();
+	{
+		for(idx = 1; idx < Textures.size(); ++idx)
+		{
+			Textures[idx]->GetLevelDesc(0, &desc);
+			Textures[idx]->LockRect(0, &rect, 0, 0);
+			memcpy(rect.pBits, textureBits, rect.Pitch*desc.Height);
+			Textures[idx]->UnlockRect(0);
+		}
+		Textures[0]->UnlockRect(0);
+	}
+	else if (RTTSurfaces[0])
+	{
+		for(idx = 1; idx < RTTSurfaces.size(); ++idx)
+		{
+			bool isSurface = true;
+			
+			D3DSURFACE_DESC desc;
+			Textures[idx]->GetLevelDesc(0, &desc);
+			if (!RTTSurfaces[idx])
+			{
+				hr = Devices[idx]->CreateOffscreenPlainSurface(desc.Width, desc.Height, desc.Format, D3DPOOL_SYSTEMMEM, &RTTSurfaces[idx], NULL);
+				if (FAILED(hr))
+				{
+					os::Printer::log("Could not lock DIRECT3D9 Textures[idx].", ELL_ERROR);
+					isSurface = false;
+				}
+			}
+
+			if(isSurface)
+			{
+				bool isSurfaceLevel = true;
+				IDirect3DSurface9 *surface = NULL;
+				hr = Textures[0]->GetSurfaceLevel(0, &surface);
+				if (FAILED(hr))
+				{
+					os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
+					isSurfaceLevel = false;
+				}
+				if(isSurfaceLevel)
+				{
+					bool isRenderTargetData = true;
+					hr = Devices[idx]->GetRenderTargetData(surface, RTTSurfaces[idx]);
+					if(FAILED(hr))
+					{
+						os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
+						isRenderTargetData = false;
+					}
+					if(isRenderTargetData)
+					{
+						bool isLocked = true;
+						hr = RTTSurfaces[idx]->LockRect(&rect, NULL, 0);
+						if(FAILED(hr))
+						{
+							os::Printer::log("Could not lock DIRECT3D9 Texture.", ELL_ERROR);
+							isLocked = false;
+						}
+						if(isLocked)
+						{
+							//rect.pBits = surfaceBits;
+							memcpy(rect.pBits, surfaceBits, rect.Pitch*desc.Height);
+
+							RTTSurfaces[idx]->UnlockRect();
+						}
+					}
+				}
+			}
+		}
+		RTTSurfaces[0]->UnlockRect();
+	}
 }
 
 
@@ -686,9 +862,9 @@
 
 
 //! returns the DIRECT3D9 Texture
-IDirect3DTexture9* CD3D9Texture::getDX9Texture()
+IDirect3DTexture9* CD3D9Texture::getDX9Texture(u32 index)
 {
-	return Texture;
+	return Textures[index];
 }
 
 
@@ -791,14 +967,14 @@
 }
 
 //! Returns pointer to the render target surface
-IDirect3DSurface9* CD3D9Texture::getRenderTargetSurface()
+IDirect3DSurface9* CD3D9Texture::getRenderTargetSurface(u32 index)
 {
 	if (!IsRenderTarget)
 		return 0;
 
 	IDirect3DSurface9 *pRTTSurface = 0;
-	if (Texture)
-		Texture->GetSurfaceLevel(0, &pRTTSurface);
+	if (Textures[index])
+		Textures[index]->GetSurfaceLevel(0, &pRTTSurface);
 
 	if (pRTTSurface)
 		pRTTSurface->Release();
diff -r -uw -N irrlicht/source/Irrlicht/CD3D9Texture.h irrlicht_multipatch/source/Irrlicht/CD3D9Texture.h
--- irrlicht/source/Irrlicht/CD3D9Texture.h	2006-10-15 08:48:52.000000000 +0200
+++ irrlicht_multipatch/source/Irrlicht/CD3D9Texture.h	2006-12-05 12:31:10.000000000 +0100
@@ -11,13 +11,15 @@
 #include "ITexture.h"
 #include "IImage.h"
 #include <d3d9.h>
+#include "irrArray.h"
 
 namespace irr
 {
 namespace video
 {
 
-class CD3D9Driver;
+class IVideoDriver;
+//class CD3D9Driver;
 /*!
 	interface for a Video Driver dependent Texture.
 */
@@ -26,11 +28,18 @@
 public:
 
 	//! constructor
-	CD3D9Texture(IImage* image, CD3D9Driver* driver,
+	CD3D9Texture(IImage* image, IVideoDriver* driver,
+		u32 flags, const char* name);
+
+	//! multihead constructor
+	CD3D9Texture(IImage* image, IVideoDriver* driver, core::array<IDirect3DDevice9*> devices,
 		u32 flags, const char* name);
 
 	//! rendertarget constructor
-	CD3D9Texture(CD3D9Driver* driver, core::dimension2d<s32> size, const char* name);
+	CD3D9Texture(IVideoDriver* driver, core::dimension2d<s32> size, const char* name);
+
+	//! rendertarget multihead constructor
+	CD3D9Texture(IVideoDriver* driver, core::array<IDirect3DDevice9*> devices, core::dimension2d<s32> size, const char* name);
 
 	//! destructor
 	virtual ~CD3D9Texture();
@@ -57,7 +66,7 @@
 	virtual s32 getPitch();
 
 	//! returns the DIRECT3D9 Texture
-	IDirect3DTexture9* getDX9Texture();
+	IDirect3DTexture9* getDX9Texture(u32 index = 0);
 
 	//! returns if texture has mipmap levels
 	bool hasMipMaps();
@@ -70,28 +79,28 @@
 	bool isRenderTarget();
 
 	//! Returns pointer to the render target surface
-	IDirect3DSurface9* getRenderTargetSurface();
+	IDirect3DSurface9* getRenderTargetSurface(u32 index = 0);
 
 private:
 
-	void createRenderTarget();
+	void createRenderTarget(IDirect3DDevice9 *device);
 
 	//! returns the size of a texture which would be the optimize size for rendering it
 	inline s32 getTextureSizeFromImageSize(s32 size);
 
 	//! creates the hardware texture
-	void createTexture(u32 flags);
+	void createTexture(u32 flags, u32 renderDevice = 0);
 
 	//! copies the image to the texture
-	bool copyTexture();
+	bool copyTexture(u32 index = 0);
 
 	//! optimized for 16 bit to 16 copy.
-	bool copyTo16BitTexture();
+	bool copyTo16BitTexture(u32 index = 0);
 
 	//! copies texture to 32 bit hardware texture
-	bool copyTo32BitTexture();
+	bool copyTo32BitTexture(u32 index = 0);
 
-	bool createMipMaps(s32 level=1);
+	bool createMipMaps(s32 level=1, u32 idx = 0);
 	
 	void copy16BitMipMap(char* src, char* tgt,
 		s32 width, s32 height,  s32 pitchsrc, s32 pitchtgt);
@@ -100,10 +109,19 @@
 		s32 width, s32 height,  s32 pitchsrc, s32 pitchtgt);
 
 	IImage* Image;
-	IDirect3DDevice9* Device;
-	IDirect3DTexture9* Texture;
-	IDirect3DSurface9* RTTSurface;
-	CD3D9Driver* Driver;
+	
+	core::array<IDirect3DDevice9*>  Devices;
+	core::array<IDirect3DTexture9*> Textures;
+	core::array<IDirect3DSurface9*> RTTSurfaces;
+
+	void *textureBits;
+	void *surfaceBits;
+
+	//IDirect3DDevice9* Device;
+	//IDirect3DTexture9* Texture;
+	//IDirect3DSurface9* RTTSurface;
+	//CD3D9Driver* Driver;
+	video::IVideoDriver* Driver;
 	core::dimension2d<s32> TextureSize;
 	core::dimension2d<s32> ImageSize;
 	s32 Pitch;
